/*
Copyright (C) 2003 Sandro Giessl <ceebx@users.sourceforge.net>

based on the Keramik configuration dialog:
Copyright (c) 2003 Maksim Orlovich <maksim.orlovich@kdemail.net>

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

*/

#ifndef DOTCURVE_CONF_H
#define DOTCURVE_CONF_H

#include <qcheckbox.h>
#include <qlabel.h>
#include <kcolorbutton.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <qgrid.h>

class QCheckBox;

class dotCURVEStyleConfig: public QGrid
{
	Q_OBJECT
public:
	dotCURVEStyleConfig(QWidget* parent);
	~dotCURVEStyleConfig();

	//This signal and the next two slots are the plugin
	//page interface
signals:
	void changed(bool);

public slots:
	void save();
	void defaults();

	//Everything below this is internal.
protected slots:
	void updateChanged();

private:

	QString scrollBarType( int listnr );
	int scrollBarItem( QString kSBType );
	
	//We store settings directly in widgets to
	//avoid the hassle of sync'ing things
	QCheckBox	*drawToolBarSeparator;
	QCheckBox	*centerTabs;
	QCheckBox	*highlightMenu;
	QCheckBox	*statusbarSeparator;
	QCheckBox	*useCustomScrollbarColor;
	KColorButton	*customScrollbarColor;
	QCheckBox	*useCustomBrushColor;
	KColorButton	*customBrushColor;
	KColorButton	*checkColor;
	KColorButton	*radioColor;
	QComboBox	*scrollBarStyle;
	QSpinBox	*tabOverlap;

	//Original settings, for accurate dirtiness tracking
	bool		origDrawToolBarSeparator;
	bool		origCenterTabs;
	bool		origHighlightMenu;
	bool		origStatusbarSeparator;
	bool		origUseCustomScrollbarColor;
	QColor		origCustomScrollbarColor;
	bool		origUseCustomBrushColor;
	QColor		origCustomBrushColor;
	QColor		origCheckColor;
	QColor		origRadioColor;
	QString		origScrollBarStyle;
	int		origTabOverlap;
};

#endif
